

UCINCLUDES=-I.
UCLIBS=-lm

#THE LOCATION FOR OUR FIGURES
#RESDIR=Figs
#
#
#
##A LIST OF FIGURE NAMES
#SAME_FIGS=same.score-path same.sim same.in-out  #same trace
#BIG_FIGS=big.score-path big.sim big.in-out     #625 trace comparison
#SMALL_FIGS=small.score-path small.sim small.in-out     #625 trace comparison
#DIFF_FIGS=diff.score-path diff.sim diff.in-out     #two close trace comparison
#BAND_FIGS=band.score-path band.sim band.in-out     #banded trace comparison;
#BAND2_FIGS=band2.score-path band2.sim band2.in-out     #banded trace comparison
#NMO_FIGS=nmo.score-path nmo.sim nmo.in-out     #banded trace comparison
#
##THE FIGURES I CONSDIER RESULTS
#RESULTSER=${SAME_FIGS} ${DIFF_FIGS} ${BIG_FIGS} ${BAND_FIGS}
#RESULTSER=same.score-path  band.score-path diff.score-path big.score-path band2.score-path
#RESULTSER=same.in-out  band.in-out diff.in-out big.in-out band2.in-out
#
#RESULTSER=${BIG_FIGS}
#RESULTSER=${NMO_FIGS} 


#NAMING CONVENTIONS TO MAKE IMPLICIT RULES WORK
#
#  base             - a single word that describes the comparison (e.g. same, diff, big)
#  base.1.in.H      - the first input trace for problem base
#  base.2.in.H      - the second input trace for problem base
#  base.1.out.H     - the first output trace for problem base
#  base.mat.H       - the matrix (first similarity, second score)
#  base.path.H      - file (complex pairs) describing the sellected path
#  base.P           - parameter file for the comparison. The parameter file
#                       should also contain the appropriate o1,d1,o2,d2, min1, max1, min2, and max2
#                       for the graphs.



nmo.gat.H nmo.1.in.HH nmo.2.in.HH:	spike.P
	Spike n1=128 nsp=5 k1=20,40,60,80,100 >a.H n2=20 d1=.016 par=spike.P 
	Wavelet par=wave.P >wave.H
	Filter filter=wave.H < a.H >b.H
	NMO inv=1 < b.H >c.H vel=2
	Noise < c.H >nmo.gat.H var=.02
	Window < nmo.gat.H >nmo.2.in.HH n2=1
	Window < nmo.gat.H >nmo.1.in.HH n2=1 f2=10

big.1.in.HH big.2.in.HH:	crp.gather.HH
	Window < crp.gather.HH >big.2.in.HH f2=3 n2=1
	Window < crp.gather.HH >big.1.in.HH f2=15 n2=1


${RESDIR}/big.gather.v:	crp.gather.HH
	Grey < crp.gather.HH out=$@ >a.V label1="Depth(km)" label2="Angle(degrees)" title=" "

${RESDIR}/big.score-sim.v: big.score-path.V big.sim.V
	Vppen gridnum=2,1 < big.sim.V big.score-path.V  >a.V out=$@ vpstyle=n yscale=2.

${RESDIR}/big.in-out.v:big.in.V big.out.V
	Cat axis=2  big.2.in.HH big.1.in.HH | Pad n2out=5 >a.H
	Add scale=1,-1 big.1.in.HH   big.2.in.HH  >c.H
	Cat axis=2 a.H c.H |Wiggle  title="Input" >a.V transp=y yreverse=y min1=2 max1=4
	Cat axis=2 big.2.in.HH  big.1.out.H |Pad n2out=5 >a.H
	Add scale=1,-1 big.1.out.H   big.2.in.HH  >c.H
	Cat axis=2 a.H c.H |Wiggle  title="Output" >b.V  yreverse=y transp=y min1=3 max1=4
	Vppen vpstyle=n < a.V b.V  >C.V out=$@ gridnum=2,1  yscale=2.
 
${RESDIR}/nmo.in-out.v:nmo.in.V nmo.out.V
	Cat axis=2  nmo.2.in.HH nmo.1.in.HH | Pad n2out=5 >a.H
	Add scale=1,-1 nmo.1.in.HH   nmo.2.in.HH  >c.H
	Cat axis=2 a.H c.H |Wiggle  title="Input" >a.V transp=y yreverse=y
	Cat axis=2 nmo.2.in.HH  nmo.1.out.H |Pad n2out=5 >a.H
	Add scale=1,-1 nmo.1.out.H   nmo.2.in.HH  >c.H
	Cat axis=2 a.H c.H |Wiggle  title="Output" >b.V  yreverse=y transp=y
	Vppen vpstyle=n < a.V b.V  >C.V out=$@ gridnum=2,1  yscale=2.

${RESDIR}/nmo.gather.v:	nmo.1.in.HH  nmo.gat.H
	Grey < nmo.gat.H out=$@ >a.V  title=" " label1="Time(s)" label2="Offset(km)"

${RESDIR}/nmo.score-sim.v: nmo.score-path.V nmo.sim.V
	Vppen gridnum=2,1 < nmo.sim.V nmo.score-path.V  >a.V out=$@ vpstyle=n yscale=2.

#${RESDIR}/nmo.in-out.v:nmo.in.V nmo.out.V
#	Cat axis=2 nmo.2.in.HH nmo.1.in.HH  |Wiggle  title="Input" >a.V transp=y yreverse=y
#	Cat axis=2 nmo.2.in.HH  nmo.1.out.H  |Wiggle  title="Output" >b.V  yreverse=y transp=y
#	Vppen vpstyle=n < a.V b.V  >C.V out=$@ gridnum=2,1  yscale=2.
	



#THE GENERAL RULE FOR RUNNING THE PROGRAM
%.1.out.H:	%.1.in.HH %.2.in.HH %.P ${BINDIR}/dynamic.x
	${BINDIR}/dynamic.x par=$*.P            < $*.1.in.HH      trace_base=$*.2.in.HH par=$*.P \
    mat=$*.mat.H path=$*.path.H           >$*.1.out.H 

#A RULE FOR CREATING the PATH INTO A VPLOT FILE.
#NOTE HOW IT DEPENDS ON THE %.1.out.H rather than %.path.H (%.1.out.H is the only thing
#specified as a taget.
%.path.V:	%.1.out.H %.P
	Graph <$*.path.H par=$*.P  yreverse=y wantaxis=n title=" " >a1.V plotcol=0 plotfat=12
	Graph <$*.path.H par=$*.P  yreverse=y wantaxis=n title=" " >a2.V plotcol=7 plotfat=8
	Vppen erase=o < a1.V a2.V >$@ vpstlye=n

#A RULE TO CREATE A SIMILARITY MATRIX PLOT
%.sim.V:	%.1.out.H %.P
	Window < $*.mat.H n3=1 | Grey allpos=n title="Similarity matrix" par=$*.P >$@

#A RULE TO CREATE A SCORE MATRIX PLOT
%.score.V:	%.1.out.H %.P
	Window < $*.mat.H f3=1 | Grey allpos=n title="Score matrix" par=$*.P >$@

#A RULE TO DO A GRAPH COMPARISON OF TWO INPUT TRACES
%.in.V:	%.1.in.HH %.2.in.HH
	Cat axis=2 $*.1.in.HH $*.2.in.HH |Graph  title="Input" >$@ transp=y yreverse=y

#A RULE TO DO A GRAPH COMPARISON OF TWO OUTPUT TRACES
%.out.V:	%.1.out.H 
	Cat axis=2 $*.1.out.H $*.2.in.HH |Graph  title="Output" >$@  yreverse=y transp=y

big.in.V:	big.1.in.HH 
	Cat axis=2 big.1.in.HH big.2.in.HH |Window n1=620 |Graph  title="Input" >$@ n1=620 

big.out.V:	big.1.out.H 
	Cat axis=2 big.1.out.H big.2.in.HH |Window n1=620 |Graph  title="Output" >$@ n1=620 f1=3


#A RULE TO MAKE A MOVIE OF THE INPUT AND OUTPUT TRACES
%.in-out.V:	%.in.V %.out.V
	Vppen vpstyle=n < $*.in.V $*.out.V >$@

#A RULE TO OVERLAY THE PATH ON TOP OF THE SCORE MATRIX
%.score-path.V:	%.score.V %.path.V
	Vppen erase=o vpstyle=n < $*.score.V $*.path.V >$@

#A RULE TO CHANGE .V to .v (.V have their binaries on the scratch disk .v are the binaries)
${RESDIR}/%.v: %.V
	Cp  $*.V  /dev/null out=$@

${BINDIR}/dynamic_old.x:	adjnull.o  cgstep.o    myalloc.o  sinc_oper.o  solver.o deriv.o iop.o

${BINDIR}/dynamic.x:	adjnull.o  cgstep.o  dynamic.o  myalloc.o  sinc_oper.o  solver.o deriv.o iop.o


clean: jclean
