#include<solver.h>
void   solver (operator oper, stepper solv, int nmod,float *mod, int ndat,
       const float* dat, int niter)
{
int i,iter;
bool forget=FALSE;
float *g,*rr,*gg;

 
 g = (float*) salloc (nmod,sizeof(float));
 rr = (float*) salloc (ndat,sizeof(float));
 gg = (float*) salloc (ndat,sizeof(float));
 for(i=0;i< ndat; i++) rr[i]=-dat[i];
 for(i=0;i< nmod; i++) mod[i]=0.0;
 
 for(iter=0; iter < niter; iter++){
   oper(TRUE,FALSE,nmod,g,ndat,rr);
   oper(FALSE,FALSE,nmod,g,ndat,gg);
    solv(forget,nmod,ndat,mod,g,rr,gg); forget=FALSE;
 }
 free(g); free(rr);free(gg);
}




void   solver_reg(operator oper, stepper solv,operator reg, int nreg,
   int nmod,float *mod, int ndat, const float* dat, int niter,float eps)
{
int i,iter;
bool forget=FALSE;
float *g,*rr,*gg,*tt;

 
 g = (float*) salloc (nmod,sizeof(float));
 tt= (float*) salloc (nmod,sizeof(float));
 rr = (float*) salloc (ndat+nreg,sizeof(float));
 gg = (float*) salloc (ndat+nreg,sizeof(float));

 for(i=0;i< ndat; i++) rr[i]=-dat[i];
 for(i=0;i< nreg; i++) rr[i+ndat]=0.;
 for(i=0;i< nmod; i++) mod[i]=0.0;
 
 for(iter=0; iter < niter; iter++){
   oper(TRUE,FALSE,nmod,g,ndat,rr);
   reg(TRUE,FALSE,nmod,tt,nreg,&(rr[ndat]));
   for(i=0;i < nmod; i++) g[i]+=tt[i]*eps;

   oper(FALSE,FALSE,nmod,g,ndat,gg);
   reg(FALSE,FALSE,nmod,g,ndat,&(gg[ndat]));
   for(i=0;i < nreg; i++) gg[i+ndat]=gg[i+ndat]*eps;

   solv(forget,nmod,ndat+nreg,mod,g,rr,gg); forget=FALSE;
 }
 free(g); free(rr);free(gg); free(tt);
}
